org.apache.http.nio.entity

## Class NFileEntity

- java.lang.Object
- - org.apache.http.entity.AbstractHttpEntity
  - - org.apache.http.nio.entity.NFileEntity

All Implemented Interfaces:
  Closeable, AutoCloseable, HttpEntity, HttpAsyncContentProducer, ProducingNHttpEntity

    @NotThreadSafe
    public class NFileEntity
    extends AbstractHttpEntity
    implements HttpAsyncContentProducer, ProducingNHttpEntity

A self contained, repeatable non-blocking entity that retrieves its content from a file. This class is mostly used to stream large files of different types, so one needs to supply the content type of the file to make sure the content can be correctly recognized and processed by the recipient.

Since:
  4.0

### Field Summary

### Fields inherited from class org.apache.http.entity.AbstractHttpEntity

`chunked, contentEncoding, contentType, OUTPUT_BUFFER_SIZE`

### Constructor Summary

Constructors
Constructor and Description
`NFileEntity(File file)`
`NFileEntity(File file, ContentType contentType)` Creates new instance of NFileEntity from the given source `File` with the given content type.
`NFileEntity(File file, ContentType contentType, boolean useFileChannels)` Creates new instance of NFileEntity from the given source `File` with the given content type.
`NFileEntity(File file, String contentType)` Deprecated. (4.2) use `NFileEntity(File, ContentType)`
`NFileEntity(File file, String contentType, boolean useFileChannels)` Deprecated. (4.2) use `NFileEntity(File, ContentType, boolean)`

### Method Summary

Methods
`void` `close()`
`void` `finish()` Deprecated. (4.2) use `close()`
`InputStream` `getContent()` Returns a content stream of the entity.
`long` `getContentLength()` Tells the length of the content, if known.
`boolean` `isRepeatable()` Determines whether or not this producer is capable of producing its content more than once.
`boolean` `isStreaming()` Tells whether this entity depends on an underlying stream.
`void` `produceContent(ContentEncoder encoder, IOControl ioctrl)` Invoked to write out a chunk of content to the `ContentEncoder`.
`void` `writeTo(OutputStream outstream)` Writes the entity content out to the output stream.

### Methods inherited from class org.apache.http.entity.AbstractHttpEntity

`consumeContent, getContentEncoding, getContentType, isChunked, setChunked, setContentEncoding, setContentEncoding, setContentType, setContentType`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.http.HttpEntity

`consumeContent, getContentEncoding, getContentType, isChunked`

### Constructor Detail

#### NFileEntity

    public NFileEntity(File file,
               ContentType contentType,
               boolean useFileChannels)

Creates new instance of NFileEntity from the given source `File` with the given content type. If `useFileChannels` is set to `true`, the entity will try to use `FileContentEncoder` interface to stream file content directly from the file channel.

Parameters:
  `file` - the source file.
  `contentType` - the content type of the file.
  `useFileChannels` - flag whether the direct transfer from the file channel should be attempted.
Since:
  4.2

#### NFileEntity

    public NFileEntity(File file)

Since:
  4.2

#### NFileEntity

    public NFileEntity(File file,
               ContentType contentType)

Creates new instance of NFileEntity from the given source `File` with the given content type.

Parameters:
  `file` - the source file.
  `contentType` - the content type of the file.
Since:
  4.2

#### NFileEntity

    @Deprecated
    public NFileEntity(File file,
                          String contentType,
                          boolean useFileChannels)

Deprecated. (4.2) use `NFileEntity(File, ContentType, boolean)`

#### NFileEntity

    @Deprecated
    public NFileEntity(File file,
                          String contentType)

Deprecated. (4.2) use `NFileEntity(File, ContentType)`

### Method Detail

#### close

    public void close()
               throws IOException

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Throws:
  `IOException`
Since:
  4.2

#### finish

    @Deprecated
    public void finish()
                throws IOException

Deprecated. (4.2) use `close()`
Notification that any resources allocated for writing can be released.

Specified by:
  `finish` in interface `ProducingNHttpEntity`
Throws:
  `IOException`

#### getContentLength

    public long getContentLength()

Description copied from interface: `HttpEntity`
Tells the length of the content, if known.

Specified by:
  `getContentLength` in interface `HttpEntity`
Returns:
  the number of bytes of the content, or a negative number if unknown. If the content length is known but exceeds `Long.MAX_VALUE`, a negative number is returned.

#### isRepeatable

    public boolean isRepeatable()

Description copied from interface: `HttpAsyncContentProducer`
Determines whether or not this producer is capable of producing its content more than once. Repeatable content producers are expected to be able to recreate their content even after having been closed.

Specified by:
  `isRepeatable` in interface `HttpEntity`
Specified by:
  `isRepeatable` in interface `HttpAsyncContentProducer`
Returns:
  true if the entity is repeatable, false otherwise.

#### produceContent

    public void produceContent(ContentEncoder encoder,
                      IOControl ioctrl)
                        throws IOException

Description copied from interface: `HttpAsyncContentProducer`
Invoked to write out a chunk of content to the `ContentEncoder`. The `IOControl` interface can be used to suspend output event notifications if the entity is temporarily unable to produce more content.

When all content is finished, the producer MUST call `ContentEncoder.complete()`. Failure to do so may cause the entity to be incorrectly delimited.

Please note that the `ContentEncoder` object is not thread-safe and should only be used within the context of this method call. The `IOControl` object can be shared and used on other thread to resume output event notifications when more content is made available.

Specified by:
  `produceContent` in interface `HttpAsyncContentProducer`
Specified by:
  `produceContent` in interface `ProducingNHttpEntity`
Parameters:
  `encoder` - content encoder.
  `ioctrl` - I/O control of the underlying connection.
Throws:
  `IOException`

#### isStreaming

    public boolean isStreaming()

Description copied from interface: `HttpEntity`
Tells whether this entity depends on an underlying stream. Streamed entities that read data directly from the socket should return `true`. Self-contained entities should return `false`. Wrapping entities should delegate this call to the wrapped entity.

Specified by:
  `isStreaming` in interface `HttpEntity`
Returns:
  `true` if the entity content is streamed, `false` otherwise

#### getContent

    public InputStream getContent()
                           throws IOException

Description copied from interface: `HttpEntity`
Returns a content stream of the entity. `Repeatable` entities are expected to create a new instance of `InputStream` for each invocation of this method and therefore can be consumed multiple times. Entities that are not `repeatable` are expected to return the same `InputStream` instance and therefore may not be consumed more than once.

IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated after the `InputStream.close()` method is invoked.

Specified by:
  `getContent` in interface `HttpEntity`
Returns:
  content stream of the entity.
Throws:
  `IOException` - if the stream could not be created
See Also:
  `HttpEntity.isRepeatable()`

#### writeTo

    public void writeTo(OutputStream outstream)
                 throws IOException

Description copied from interface: `HttpEntity`
Writes the entity content out to the output stream.

IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated when this method returns.

Specified by:
  `writeTo` in interface `HttpEntity`
Parameters:
  `outstream` - the output stream to write entity content to
Throws:
  `IOException` - if an I/O error occurs